using System;
using System.Web;
using System.Net;
using System.IO;
using System.Collections;
using Microsoft.Win32;
using System.Reflection;
using System.Diagnostics;

using FTPLib;

namespace ProjServHandler
{
  public delegate void ProgressChanged(int  CurProgress,
                                       long FileSize,
                                       long TotalBytesLeft);

	/// <summary>
	/// Web Handler
	/// Team Server-hez - CheckOut(); CheckIn(); GetFileNamesFromProjServer();
	/// </summary>
	public class WebHandler
  {
    #region Vltozk
    //
    //Ha egy fgvny visszatrsi rtke false akkor ebben a vltozban tallhat a hibazenet.
    //
 	  public string LastError = "";
 	  
 	  //
 	  //Az FTP Server hasznlathoz szksges osztly.
 	  //
	  public FTP ftp = new FTP();
	  
	  //
	  //Fjl feltlts s letltskor(Ki-,Be- csekkols) a progressbar hasznlathoz szksges adatokat szolgltat 
	  //esemny.
	  //
	  public event ProgressChanged ProgressChangedEvent;
	  
	  //
	  //A log rshoz szksges osztly.
	  //
	  Global g = Global.Instance;
	  
	  //
	  //A Team Server homelap cme.
	  //
	  public string ServerPath = "";

    //
    //FTP-hez szksges adatok.
    //
    public string server = "";
    public string user   = "";
    public string pass   = "";
    public int    port   = 21;
    
    //
    //Login utn kapott szm mely azonostja a felhasznlt.
    //
    private int UserId = 0;
	  #endregion
	
    #region Constructor
    public WebHandler(string pServerPath,
                      string pServer,
                      string pUser,
                      string pPass,
                      int    pPort)
    {
      ServerPath = pServerPath;
      server     = pServer;
      user       = pUser;
      pass       = pPass;
      port       = pPort;
    }
		#endregion
		
		
    #region GetDataFromServer
    public string GetDataFromServer(string QueryString)
    {
      WebRequest reqest = WebRequest.Create(QueryString);
      WebResponse response = reqest.GetResponse();
      StreamReader sr = new StreamReader(response.GetResponseStream());
      string read = sr.ReadToEnd();
      reqest.Abort();
      response.Close();
      sr.Close();
      return read;
    }
    #endregion
		
		
		#region Login
		public bool Login(string User,
		                  string Pass)
		{
      string Ret = GetDataFromServer(ServerPath + "\\projserv.php?Check=Out&FileName=" + FileName);
      if(Ret.IndexOf("ok ret") != -1)
      {
      }
      else
      {}		
		}
		#endregion
		
    #region CheckOut
    public bool CheckOut(string  FileName,
		                     string  SavePath)
		{
		  string Ret = GetDataFromServer(ServerPath + "\\projserv.php?Comm=Login&User=" + User + "&Pass=" + Pass);
		  if(Ret.IndexOf("ok ret") != -1)
		  {
        try
        {
          UserId = Ret.Remove(0,7);
          
          return true;
        }
		    catch(System.Exception e)
		    {
          UserId = 0;
		      return false;
		    }
		  }
		  else
		  {
		    LastError = Ret;
		    return false;
		  }
		}
		
    public bool CheckOutNoEvent(string FileName,
                                string SavePath)
    {
      string Ret = GetDataFromServer(ServerPath + "\\projserv.php?Check=Out&FileName=" + FileName);
      if(Ret.IndexOf("ok ret") != -1)
      {
        try
        {
          
          ftp.server = server;
          ftp.user   = user;
          ftp.pass   = pass;
          ftp.port   = 21;    
          ftp.Connect();
          
          ftp.ChangeDir("/wwwroot");
          ftp.ChangeDir("/wwwroot/Files");  
          
          ftp.OpenDownload(FileName,SavePath,true);   
          
          try
          {
            g.CheckedOutFiles.Add(FileName); 
          }
          catch
          {}  
          return true;
        }
        catch(System.Exception e)
        {
          LastError = e.Message;
          return false;
        }
      }
      else
      {
        LastError = Ret;
        return false;
      }
    }
    
    public bool DoCheckOut(ref int  CurProgress,
                           ref long TotalLeftBytes,
                           ref long FileSize)
    { 
      int perc = 0;
			
      while(ftp.DoDownload() > 0)
      {
        perc = (int)(((ftp.BytesTotal) * 100) / ftp.FileSize);
        CurProgress = perc;
        FileSize = ftp.FileSize;
        TotalLeftBytes = ftp.BytesTotal;
        return true;
      }
          
      ftp.Disconnect();   
          
      
      return false;  
    }
		#endregion
		
    #region CheckIn
    public bool CheckIn(string FileName,
                        string FileNameOnServer)
    {
      string Ret = GetDataFromServer(ServerPath + "\\projserv.php?Check=In&FileName=" + FileNameOnServer);
      if(Ret.IndexOf("ok ret") != -1)
      {
        try
        {
          
          ftp.server = server;
          ftp.user   = user;
          ftp.pass   = pass;
          ftp.port   = 21;         
          ftp.Connect();
          
          ftp.ChangeDir("/wwwroot");
          ftp.ChangeDir("/wwwroot/Files");  
          
          ftp.OpenUpload(FileName,FileNameOnServer,false);
          int perc = 0;
			
          while(ftp.DoUpload() > 0)
          {
            perc = (int)(((ftp.BytesTotal) * 100) / ftp.FileSize);
            ProgressChangedEvent(perc, ftp.FileSize, ftp.BytesTotal);
          }  
          
          ftp.Disconnect();
          
          try
          {
            g.CheckedOutFiles.Remove(FileName); 
          }
          catch
          {}             
          return true;
        }
        catch(System.Exception e)
        {
          //GetDataFromServer("http://jap-projserv.extra.hu/projserv.php?Check=Out&FileName=" + FileNameOnServer);
          LastError = e.Message;
          return false;
        }
      }
      else
      {
        LastError = Ret;
        return false;
      }
    }
    
    public bool CheckInNoEvent(string FileName,
                               string FileNameOnServer)
    {
      string Ret = GetDataFromServer(ServerPath + "\\projserv.php?Check=In&FileName=" + FileNameOnServer);
      if(Ret.IndexOf("ok ret") != -1)
      {
        try
        {
          
          ftp.server = server;
          ftp.user   = user;
          ftp.pass   = pass;
          ftp.port   = 21;         
          ftp.Connect();
          
          ftp.ChangeDir("/wwwroot");
          ftp.ChangeDir("/wwwroot/Files");  
          
          ftp.OpenUpload(FileName,FileNameOnServer,false);
          try
          {
            g.CheckedOutFiles.Remove(FileName); 
          }
          catch
          {}  
          return true;
        }
        catch(System.Exception e)
        {
          LastError = e.Message;
          return false;
        }
      }
      else
      {
        LastError = Ret;
        return false;
      }
    }
    
    public bool DoCheckIn(ref int CurProgress,
                          ref long TotalLeftBytes,
                          ref long FileSize)
    {             
      int perc = 0;
			
      while(ftp.DoUpload() > 0)
      {
        perc = (int)(((ftp.BytesTotal) * 100) / ftp.FileSize);
        CurProgress = perc;
        FileSize = ftp.FileSize;
        TotalLeftBytes = ftp.BytesTotal;
        return true;
      }  
          
      ftp.Disconnect();
           
      return false;  
    }
    #endregion
    
    #region GetFileNamesFromTheProjServer
    public bool GetFileNamesFromTheProjServer(ref ArrayList FileNames)
    {
      try
      {
        ftp.server = server;
        ftp.user   = user;
        ftp.pass   = pass;
        ftp.port   = 21;         
        ftp.Connect();
          
        ftp.ChangeDir("/wwwroot");
        ftp.ChangeDir("/wwwroot/Files");  
          
        ArrayList FNames = ftp.ListFiles();
        FileNames = (ArrayList)FNames.Clone();
        string[] Names = GetDataFromServer(ServerPath + "\\projserv.php").Split('|'); 
        int i = 0;
        foreach(string s in FNames)
        {
          string CheckState = "Checked In";
          string Name = s.Substring(s.LastIndexOf(" ")+1);
          foreach(string n in Names)
          {
            if(Name == n)
            {
              CheckState = "Checked Out";
              break;
            }
          }
          FileNames[i] = Name + "|" + CheckState;
          i++;
        }
        
        ftp.Disconnect();
        return true;
      }
      catch(System.Exception e)
      {
        LastError = e.Message;
        return false;
      }
    }
    #endregion
  }
}
