using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Threading;
using System.Collections.Specialized;

using XPTable.Renderers;
using XPTable.Themes;
using XPTable.Models;
using JWorldBuilder.Logging;
using JadamPrograms.TeamServer.Dialogs;

namespace JadamPrograms.TeamServer
{
	/// <summary>
	/// This is a tool to use Project Servers. 
	/// </summary>
	public class TeamServManager : System.Windows.Forms.Form
	{
    #region Init and Variables
    private System.Windows.Forms.StatusBar statusBar1;
    private XPTable.Models.ImageColumn FileState;
    private XPTable.Models.TextColumn FileName;
    private XPTable.Models.ProgressBarColumn Progress;
    private XPTable.Models.ButtonColumn CheckOut;
    private XPTable.Models.ButtonColumn CheckIn;
    private System.ComponentModel.IContainer components;
    private WebHandler wh;
    ArrayList Names = new ArrayList();
    ArrayList FileNames = new ArrayList();    
		Global g = Global.Instance;
    private System.Windows.Forms.Button btnRefresh;
    private System.Windows.Forms.Button btnUpload;
    private System.Windows.Forms.OpenFileDialog openFileDialog1;
		public static string SavePath = "";
		public static NameValueCollection ThreadRows = new NameValueCollection();
		public static Logger log;
    
    
    public  System.Windows.Forms.ImageList ilStates;
    private System.Windows.Forms.Panel pnlCmdInfo;
    private System.Windows.Forms.Panel pnlTools;
    private System.Windows.Forms.Button btnSettings;
    private System.Windows.Forms.RichTextBox rtbInfos;
    private System.Windows.Forms.Button btnConnect;
    private System.Windows.Forms.ImageList ilButtons;
    private System.Windows.Forms.Button btnDisConnect;
    private System.Windows.Forms.Button btnExit;
    private System.Windows.Forms.Splitter spt1;
    private System.Windows.Forms.Splitter spt2;
    private System.Windows.Forms.Splitter spt3;
    private System.Windows.Forms.Splitter splitter1;
    private System.Windows.Forms.StatusBarPanel stbStatus;
    private System.Windows.Forms.StatusBarPanel stbServer;
    private System.Windows.Forms.StatusBarPanel stbUser;
		public static string serverpath = "";		
		public static string server     = "";
		public static string user       = "";		
		public static string pass       = "";
		public static int    UserId     = 0;
    private System.Windows.Forms.ProgressBar progressBar1;		
		public static int    port   = 21;
    private System.Windows.Forms.Button button1;
    private System.Windows.Forms.Button btnDataModify;
    private XPTable.Models.Table FilesTable;
    private XPTable.Models.Table table1;
    public XPTable.Models.TableModel FilesTableModel;
    private XPTable.Models.ColumnModel FilesColumnModel;
    private XPTable.Models.ImageColumn icFileState;
    private XPTable.Models.TextColumn tcFileName;
    private XPTable.Models.ProgressBarColumn pcProgress;
    private XPTable.Models.ButtonColumn bcCheckOut;
    private XPTable.Models.ButtonColumn bcCheckIn;
		
		public static int ActiveThreads = 0;		
		#endregion
		
    #region Constructor
 		public TeamServManager(string pSavePath)
		{
			SavePath = pSavePath;
			log = new Logger(Application.StartupPath + "\\ProjSerManager_Log.html");
				
			InitializeComponent();		
     
      GradientHeaderRenderer ghr = new GradientHeaderRenderer();    
      this.FilesTable.HeaderRenderer = ghr; 
      
      
      
      this.progressBar1.Parent = this.statusBar1;
      this.progressBar1.Dock = DockStyle.Right;
		}
    public TeamServManager()
    {
      SavePath = Application.StartupPath + "\\CheckedOut\\";
      log = new Logger(Application.StartupPath + "\\ProjSerManager_Log.html");
				
      InitializeComponent();		
     
      GradientHeaderRenderer ghr = new GradientHeaderRenderer();    
      this.FilesTable.HeaderRenderer = ghr; 
      
      //wh.ProgressChangedEvent += new ProgressChanged(wh_ProgressChangedEvent);
      
      this.progressBar1.Parent = this.statusBar1;
      this.progressBar1.Dock = DockStyle.Right;
    }
		#endregion

    #region Dispose
 		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}
		#endregion

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
      this.components = new System.ComponentModel.Container();
      System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(TeamServManager));
      this.ilStates = new System.Windows.Forms.ImageList(this.components);
      this.statusBar1 = new System.Windows.Forms.StatusBar();
      this.stbStatus = new System.Windows.Forms.StatusBarPanel();
      this.stbServer = new System.Windows.Forms.StatusBarPanel();
      this.stbUser = new System.Windows.Forms.StatusBarPanel();
      this.pnlCmdInfo = new System.Windows.Forms.Panel();
      this.rtbInfos = new System.Windows.Forms.RichTextBox();
      this.pnlTools = new System.Windows.Forms.Panel();
      this.btnRefresh = new System.Windows.Forms.Button();
      this.ilButtons = new System.Windows.Forms.ImageList(this.components);
      this.spt3 = new System.Windows.Forms.Splitter();
      this.btnSettings = new System.Windows.Forms.Button();
      this.spt2 = new System.Windows.Forms.Splitter();
      this.btnExit = new System.Windows.Forms.Button();
      this.btnUpload = new System.Windows.Forms.Button();
      this.spt1 = new System.Windows.Forms.Splitter();
      this.button1 = new System.Windows.Forms.Button();
      this.btnDataModify = new System.Windows.Forms.Button();
      this.btnDisConnect = new System.Windows.Forms.Button();
      this.btnConnect = new System.Windows.Forms.Button();
      this.FileState = new XPTable.Models.ImageColumn();
      this.FileName = new XPTable.Models.TextColumn();
      this.Progress = new XPTable.Models.ProgressBarColumn();
      this.CheckOut = new XPTable.Models.ButtonColumn();
      this.CheckIn = new XPTable.Models.ButtonColumn();
      this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
      this.splitter1 = new System.Windows.Forms.Splitter();
      this.progressBar1 = new System.Windows.Forms.ProgressBar();
      this.FilesTable = new XPTable.Models.Table();
      this.table1 = new XPTable.Models.Table();
      this.FilesColumnModel = new XPTable.Models.ColumnModel();
      this.icFileState = new XPTable.Models.ImageColumn();
      this.tcFileName = new XPTable.Models.TextColumn();
      this.pcProgress = new XPTable.Models.ProgressBarColumn();
      this.bcCheckOut = new XPTable.Models.ButtonColumn();
      this.bcCheckIn = new XPTable.Models.ButtonColumn();
      this.FilesTableModel = new XPTable.Models.TableModel();
      ((System.ComponentModel.ISupportInitialize)(this.stbStatus)).BeginInit();
      ((System.ComponentModel.ISupportInitialize)(this.stbServer)).BeginInit();
      ((System.ComponentModel.ISupportInitialize)(this.stbUser)).BeginInit();
      this.pnlCmdInfo.SuspendLayout();
      this.pnlTools.SuspendLayout();
      ((System.ComponentModel.ISupportInitialize)(this.FilesTable)).BeginInit();
      ((System.ComponentModel.ISupportInitialize)(this.table1)).BeginInit();
      this.SuspendLayout();
      // 
      // ilStates
      // 
      this.ilStates.ImageSize = new System.Drawing.Size(16, 16);
      this.ilStates.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ilStates.ImageStream")));
      this.ilStates.TransparentColor = System.Drawing.Color.Transparent;
      // 
      // statusBar1
      // 
      this.statusBar1.Location = new System.Drawing.Point(0, 544);
      this.statusBar1.Name = "statusBar1";
      this.statusBar1.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
                                                                                  this.stbStatus,
                                                                                  this.stbServer,
                                                                                  this.stbUser});
      this.statusBar1.ShowPanels = true;
      this.statusBar1.Size = new System.Drawing.Size(712, 22);
      this.statusBar1.TabIndex = 1;
      this.statusBar1.Text = "Ready.";
      // 
      // stbStatus
      // 
      this.stbStatus.Icon = ((System.Drawing.Icon)(resources.GetObject("stbStatus.Icon")));
      this.stbStatus.Text = "Rendben.";
      // 
      // stbServer
      // 
      this.stbServer.Icon = ((System.Drawing.Icon)(resources.GetObject("stbServer.Icon")));
      this.stbServer.Text = "Nincs kapcsolat.";
      this.stbServer.Width = 150;
      // 
      // stbUser
      // 
      this.stbUser.Icon = ((System.Drawing.Icon)(resources.GetObject("stbUser.Icon")));
      this.stbUser.Text = "Nincs felhasznl.";
      this.stbUser.Width = 120;
      // 
      // pnlCmdInfo
      // 
      this.pnlCmdInfo.Controls.Add(this.rtbInfos);
      this.pnlCmdInfo.Controls.Add(this.pnlTools);
      this.pnlCmdInfo.Dock = System.Windows.Forms.DockStyle.Top;
      this.pnlCmdInfo.Location = new System.Drawing.Point(0, 0);
      this.pnlCmdInfo.Name = "pnlCmdInfo";
      this.pnlCmdInfo.Size = new System.Drawing.Size(712, 168);
      this.pnlCmdInfo.TabIndex = 2;
      // 
      // rtbInfos
      // 
      this.rtbInfos.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(232)), ((System.Byte)(238)), ((System.Byte)(249)));
      this.rtbInfos.Dock = System.Windows.Forms.DockStyle.Fill;
      this.rtbInfos.Location = new System.Drawing.Point(0, 56);
      this.rtbInfos.Name = "rtbInfos";
      this.rtbInfos.Size = new System.Drawing.Size(712, 112);
      this.rtbInfos.TabIndex = 4;
      this.rtbInfos.Text = "";
      this.rtbInfos.TextChanged += new System.EventHandler(this.rtbInfos_TextChanged);
      // 
      // pnlTools
      // 
      this.pnlTools.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(232)), ((System.Byte)(238)), ((System.Byte)(249)));
      this.pnlTools.Controls.Add(this.btnRefresh);
      this.pnlTools.Controls.Add(this.spt3);
      this.pnlTools.Controls.Add(this.btnSettings);
      this.pnlTools.Controls.Add(this.spt2);
      this.pnlTools.Controls.Add(this.btnExit);
      this.pnlTools.Controls.Add(this.btnUpload);
      this.pnlTools.Controls.Add(this.spt1);
      this.pnlTools.Controls.Add(this.button1);
      this.pnlTools.Controls.Add(this.btnDataModify);
      this.pnlTools.Controls.Add(this.btnDisConnect);
      this.pnlTools.Controls.Add(this.btnConnect);
      this.pnlTools.Dock = System.Windows.Forms.DockStyle.Top;
      this.pnlTools.Location = new System.Drawing.Point(0, 0);
      this.pnlTools.Name = "pnlTools";
      this.pnlTools.Size = new System.Drawing.Size(712, 56);
      this.pnlTools.TabIndex = 3;
      // 
      // btnRefresh
      // 
      this.btnRefresh.Dock = System.Windows.Forms.DockStyle.Left;
      this.btnRefresh.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnRefresh.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
      this.btnRefresh.ImageIndex = 4;
      this.btnRefresh.ImageList = this.ilButtons;
      this.btnRefresh.Location = new System.Drawing.Point(489, 0);
      this.btnRefresh.Name = "btnRefresh";
      this.btnRefresh.Size = new System.Drawing.Size(80, 56);
      this.btnRefresh.TabIndex = 0;
      this.btnRefresh.Text = "Frissts";
      this.btnRefresh.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
      this.btnRefresh.Click += new System.EventHandler(this.btnRefresh_Click);
      // 
      // ilButtons
      // 
      this.ilButtons.ColorDepth = System.Windows.Forms.ColorDepth.Depth32Bit;
      this.ilButtons.ImageSize = new System.Drawing.Size(32, 32);
      this.ilButtons.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("ilButtons.ImageStream")));
      this.ilButtons.TransparentColor = System.Drawing.Color.Transparent;
      // 
      // spt3
      // 
      this.spt3.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(0)));
      this.spt3.Enabled = false;
      this.spt3.Location = new System.Drawing.Point(486, 0);
      this.spt3.Name = "spt3";
      this.spt3.Size = new System.Drawing.Size(3, 56);
      this.spt3.TabIndex = 8;
      this.spt3.TabStop = false;
      this.spt3.Visible = false;
      // 
      // btnSettings
      // 
      this.btnSettings.Dock = System.Windows.Forms.DockStyle.Left;
      this.btnSettings.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnSettings.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
      this.btnSettings.ImageIndex = 3;
      this.btnSettings.ImageList = this.ilButtons;
      this.btnSettings.Location = new System.Drawing.Point(406, 0);
      this.btnSettings.Name = "btnSettings";
      this.btnSettings.Size = new System.Drawing.Size(80, 56);
      this.btnSettings.TabIndex = 2;
      this.btnSettings.Text = "Karbantars";
      this.btnSettings.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
      this.btnSettings.Visible = false;
      this.btnSettings.Click += new System.EventHandler(this.btnSettings_Click);
      // 
      // spt2
      // 
      this.spt2.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(0)));
      this.spt2.Enabled = false;
      this.spt2.Location = new System.Drawing.Point(403, 0);
      this.spt2.Name = "spt2";
      this.spt2.Size = new System.Drawing.Size(3, 56);
      this.spt2.TabIndex = 7;
      this.spt2.TabStop = false;
      // 
      // btnExit
      // 
      this.btnExit.Dock = System.Windows.Forms.DockStyle.Right;
      this.btnExit.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnExit.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
      this.btnExit.ImageIndex = 5;
      this.btnExit.ImageList = this.ilButtons;
      this.btnExit.Location = new System.Drawing.Point(632, 0);
      this.btnExit.Name = "btnExit";
      this.btnExit.Size = new System.Drawing.Size(80, 56);
      this.btnExit.TabIndex = 5;
      this.btnExit.Text = "Kilps";
      this.btnExit.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
      this.btnExit.Click += new System.EventHandler(this.btnExit_Click);
      // 
      // btnUpload
      // 
      this.btnUpload.Dock = System.Windows.Forms.DockStyle.Left;
      this.btnUpload.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnUpload.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
      this.btnUpload.ImageIndex = 2;
      this.btnUpload.ImageList = this.ilButtons;
      this.btnUpload.Location = new System.Drawing.Point(323, 0);
      this.btnUpload.Name = "btnUpload";
      this.btnUpload.Size = new System.Drawing.Size(80, 56);
      this.btnUpload.TabIndex = 1;
      this.btnUpload.Text = "File feltlts";
      this.btnUpload.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
      this.btnUpload.Click += new System.EventHandler(this.btnUpload_Click);
      // 
      // spt1
      // 
      this.spt1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(0)));
      this.spt1.Enabled = false;
      this.spt1.Location = new System.Drawing.Point(320, 0);
      this.spt1.Name = "spt1";
      this.spt1.Size = new System.Drawing.Size(3, 56);
      this.spt1.TabIndex = 6;
      this.spt1.TabStop = false;
      // 
      // button1
      // 
      this.button1.Dock = System.Windows.Forms.DockStyle.Left;
      this.button1.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.button1.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
      this.button1.ImageIndex = 7;
      this.button1.ImageList = this.ilButtons;
      this.button1.Location = new System.Drawing.Point(240, 0);
      this.button1.Name = "button1";
      this.button1.Size = new System.Drawing.Size(80, 56);
      this.button1.TabIndex = 9;
      this.button1.Text = "zenetek";
      this.button1.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
      this.button1.Visible = false;
      // 
      // btnDataModify
      // 
      this.btnDataModify.Dock = System.Windows.Forms.DockStyle.Left;
      this.btnDataModify.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnDataModify.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
      this.btnDataModify.ImageIndex = 6;
      this.btnDataModify.ImageList = this.ilButtons;
      this.btnDataModify.Location = new System.Drawing.Point(160, 0);
      this.btnDataModify.Name = "btnDataModify";
      this.btnDataModify.Size = new System.Drawing.Size(80, 56);
      this.btnDataModify.TabIndex = 10;
      this.btnDataModify.Text = "Profil szerk.";
      this.btnDataModify.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
      this.btnDataModify.Visible = false;
      // 
      // btnDisConnect
      // 
      this.btnDisConnect.Dock = System.Windows.Forms.DockStyle.Left;
      this.btnDisConnect.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnDisConnect.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
      this.btnDisConnect.ImageIndex = 1;
      this.btnDisConnect.ImageList = this.ilButtons;
      this.btnDisConnect.Location = new System.Drawing.Point(80, 0);
      this.btnDisConnect.Name = "btnDisConnect";
      this.btnDisConnect.Size = new System.Drawing.Size(80, 56);
      this.btnDisConnect.TabIndex = 1;
      this.btnDisConnect.Text = "Logout";
      this.btnDisConnect.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
      this.btnDisConnect.Click += new System.EventHandler(this.btnDisConnect_Click);
      // 
      // btnConnect
      // 
      this.btnConnect.Dock = System.Windows.Forms.DockStyle.Left;
      this.btnConnect.FlatStyle = System.Windows.Forms.FlatStyle.Flat;
      this.btnConnect.ImageAlign = System.Drawing.ContentAlignment.TopCenter;
      this.btnConnect.ImageIndex = 0;
      this.btnConnect.ImageList = this.ilButtons;
      this.btnConnect.Location = new System.Drawing.Point(0, 0);
      this.btnConnect.Name = "btnConnect";
      this.btnConnect.Size = new System.Drawing.Size(80, 56);
      this.btnConnect.TabIndex = 4;
      this.btnConnect.Text = "Login";
      this.btnConnect.TextAlign = System.Drawing.ContentAlignment.BottomCenter;
      this.btnConnect.Click += new System.EventHandler(this.btnConnect_Click);
      // 
      // FileState
      // 
      this.FileState.Image = ((System.Drawing.Image)(resources.GetObject("FileState.Image")));
      this.FileState.Text = "File llapota";
      this.FileState.ToolTipText = "Checked In,Checked Out...";
      this.FileState.Width = 120;
      // 
      // FileName
      // 
      this.FileName.Text = "Filenv";
      this.FileName.Width = 180;
      // 
      // Progress
      // 
      this.Progress.Text = "Progress";
      this.Progress.Width = 200;
      // 
      // CheckOut
      // 
      this.CheckOut.Text = "Kicsekkols";
      this.CheckOut.Width = 70;
      // 
      // CheckIn
      // 
      this.CheckIn.Text = "Becsekkols";
      this.CheckIn.Width = 82;
      // 
      // splitter1
      // 
      this.splitter1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(255)), ((System.Byte)(128)), ((System.Byte)(0)));
      this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
      this.splitter1.Location = new System.Drawing.Point(0, 168);
      this.splitter1.Name = "splitter1";
      this.splitter1.Size = new System.Drawing.Size(712, 3);
      this.splitter1.TabIndex = 4;
      this.splitter1.TabStop = false;
      // 
      // progressBar1
      // 
      this.progressBar1.Location = new System.Drawing.Point(384, 544);
      this.progressBar1.Name = "progressBar1";
      this.progressBar1.Size = new System.Drawing.Size(312, 23);
      this.progressBar1.TabIndex = 5;
      // 
      // FilesTable
      // 
      this.FilesTable.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(232)), ((System.Byte)(238)), ((System.Byte)(249)));
      this.FilesTable.Dock = System.Windows.Forms.DockStyle.Fill;
      this.FilesTable.GridColor = System.Drawing.Color.DarkGray;
      this.FilesTable.GridLines = XPTable.Models.GridLines.Both;
      this.FilesTable.HeaderFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
      this.FilesTable.Location = new System.Drawing.Point(0, 168);
      this.FilesTable.Name = "FilesTable";
      this.FilesTable.NoItemsText = "Krem kapcsoldjon a Team Server-hez!";
      this.FilesTable.SelectionStyle = XPTable.Models.SelectionStyle.Grid;
      this.FilesTable.Size = new System.Drawing.Size(712, 376);
      this.FilesTable.TabIndex = 3;
      this.FilesTable.CellButtonClicked += new XPTable.Events.CellButtonEventHandler(this.FilesTable_CellButtonClicked);
      // 
      // table1
      // 
      this.table1.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(232)), ((System.Byte)(238)), ((System.Byte)(249)));
      this.table1.ColumnModel = this.FilesColumnModel;
      this.table1.Dock = System.Windows.Forms.DockStyle.Fill;
      this.table1.GridColor = System.Drawing.Color.FromArgb(((System.Byte)(192)), ((System.Byte)(192)), ((System.Byte)(255)));
      this.table1.GridLines = XPTable.Models.GridLines.Both;
      this.table1.HeaderFont = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
      this.table1.Location = new System.Drawing.Point(0, 171);
      this.table1.Name = "table1";
      this.table1.NoItemsText = "Kapcsoldj a Project Serverhez!";
      this.table1.Size = new System.Drawing.Size(712, 373);
      this.table1.TabIndex = 6;
      this.table1.TableModel = this.FilesTableModel;
      this.table1.Text = "table1";
      this.table1.CellButtonClicked += new XPTable.Events.CellButtonEventHandler(this.FilesTable_CellButtonClicked);
      // 
      // FilesColumnModel
      // 
      this.FilesColumnModel.Columns.AddRange(new XPTable.Models.Column[] {
                                                                           this.icFileState,
                                                                           this.tcFileName,
                                                                           this.pcProgress,
                                                                           this.bcCheckOut,
                                                                           this.bcCheckIn});
      // 
      // icFileState
      // 
      this.icFileState.Image = ((System.Drawing.Image)(resources.GetObject("icFileState.Image")));
      this.icFileState.Text = "File llapota";
      this.icFileState.Width = 120;
      // 
      // tcFileName
      // 
      this.tcFileName.Text = "Filenv";
      this.tcFileName.Width = 180;
      // 
      // pcProgress
      // 
      this.pcProgress.Text = "Progress";
      this.pcProgress.Width = 200;
      // 
      // bcCheckOut
      // 
      this.bcCheckOut.Text = "Kicsekkols";
      this.bcCheckOut.Width = 80;
      // 
      // bcCheckIn
      // 
      this.bcCheckIn.Text = "Becsekkols";
      this.bcCheckIn.Width = 82;
      // 
      // FilesTableModel
      // 
      this.FilesTableModel.RowHeight = 20;
      // 
      // TeamServManager
      // 
      this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
      this.BackColor = System.Drawing.Color.FromArgb(((System.Byte)(232)), ((System.Byte)(238)), ((System.Byte)(249)));
      this.ClientSize = new System.Drawing.Size(712, 566);
      this.Controls.Add(this.table1);
      this.Controls.Add(this.progressBar1);
      this.Controls.Add(this.splitter1);
      this.Controls.Add(this.pnlCmdInfo);
      this.Controls.Add(this.statusBar1);
      this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
      this.MinimumSize = new System.Drawing.Size(720, 600);
      this.Name = "TeamServManager";
      this.Text = "JAP Team Server Manager";
      this.Closing += new System.ComponentModel.CancelEventHandler(this.TeamServManager_Closing);
      this.Load += new System.EventHandler(this.ProjServManager_Load);
      ((System.ComponentModel.ISupportInitialize)(this.stbStatus)).EndInit();
      ((System.ComponentModel.ISupportInitialize)(this.stbServer)).EndInit();
      ((System.ComponentModel.ISupportInitialize)(this.stbUser)).EndInit();
      this.pnlCmdInfo.ResumeLayout(false);
      this.pnlTools.ResumeLayout(false);
      ((System.ComponentModel.ISupportInitialize)(this.FilesTable)).EndInit();
      ((System.ComponentModel.ISupportInitialize)(this.table1)).EndInit();
      this.ResumeLayout(false);

    }
		#endregion

    #region Main
    /// <summary>
    /// A fo belpsi pont.
    /// </summary>
    [STAThread]
    static void Main() 
    {
      Application.Run(new TeamServManager());
    }
    #endregion
   
    #region Load
    private void ProjServManager_Load(object sender, System.EventArgs e)
    {

 
    }
    #endregion
    
    #region MakeRows
    public void MakeRows(object state)
    {
      try
      {
        //Ne mdusuljon a form generlskor
        this.table1.SuspendLayout();
        
        //Threadek szmnak nvelse
        ActiveThreads++;
        this.progressBar1.Value = 0;
        this.progressBar1.Maximum = 4;
        this.Refresh();
        this.rtbInfos.Text += "Kapcsolds:" + server + "..." + "\n"; 
        this.progressBar1.Value = 1;
        this.Refresh();
        FilesTableModel.Rows.Clear();
        this.rtbInfos.Text += "Filenevek ltezsnek ellenrzse" + "\n"; 
        this.progressBar1.Value = 2;
        this.Refresh();
        if(FileNames != null)
        {
          this.rtbInfos.Text += "Tbla elksztse..." + "\n";
          this.progressBar1.Value = 3;
          this.Refresh();

          Names = FileNames;
          Row[] FileRows = new Row[Names.Count];  
      
          int i = 0;
          foreach(string name in Names)
          {
            #region Row
            FileRows[i] = new Row();     
            #endregion
      
            #region n & state
            string n = (name.Split('|'))[0];
            string s = (name.Split('|'))[1];        
            #endregion
             
            #region 0
            Image img;
            if(s == "Checked In")
            {
              img = ilStates.Images[0];
              s = "Becsekkolt";   
            }
            else
            {
              if(g.CheckedOutFiles.IndexOf(n) != -1)
              {
                img = ilStates.Images[1];          
              }
              else
              {
                img = ilStates.Images[2];
              }
              s = s.Replace("Checked Out","Kicsekkolt");  
            }
            FileRows[i].Cells.Add(new Cell(s,img,new CellStyle()));
            #endregion
        
            #region 1
            FileRows[i].Cells.Add(new Cell(n));
            #endregion
        
            #region 2
            FileRows[i].Cells.Add(new Cell(0));
            #endregion
        
            #region 3
            FileRows[i].Cells.Add(new Cell("Kicsekkols"));
            if(s == "Becsekkolt")
            {
              FileRows[i].Cells[3].Enabled = true;   
            }
            else
            {
              FileRows[i].Cells[3].Enabled = false;  
            }          
            #endregion
             
            #region 4
            FileRows[i].Cells.Add(new Cell("Becsekkols"));        
            if(s == "Becsekkolt")
            {
              FileRows[i].Cells[4].Enabled = false;   
            }
            else
            {
              if(g.CheckedOutFiles.IndexOf(n) != -1)
              {
                FileRows[i].Cells[4].Enabled = true;  
              }
              else
              {
                FileRows[i].Cells[4].Enabled = false; 
              }
            }         
            #endregion
        
            #region i
            i++;    
            #endregion
          }
      
          FilesTableModel.Rows.AddRange(FileRows);
          this.rtbInfos.Text += "Befejezve!!!" + "\n";
          this.progressBar1.Value = 4;
          this.Refresh();
          this.progressBar1.Value = 0;
          this.progressBar1.Maximum = 100;
          this.Refresh();         
        }
        else
        {
          this.rtbInfos.Text += "Hiba:" + wh.LastError + "\n";
          this.rtbInfos.Text += "Krem mieltt a szervert hasznln teleptse a JAP Team Servert!" + "\n";
          this.progressBar1.Value = 0;
          this.progressBar1.Maximum = 4;
          this.Refresh();
          this.stbServer.Text = "Nincs kapcsolat";
          this.stbUser.Text = "Nincs felhasznl";      
        }
      }
      catch(System.Exception e)
      {
        this.rtbInfos.Text += "Hiba:" + e.Message + "\n";
        this.progressBar1.Value = 0;
        this.progressBar1.Maximum = 4;
        this.Refresh();
        this.stbServer.Text = "Nincs kapcsolat";
        this.stbUser.Text = "Nincs felhasznl";    
      }
      ActiveThreads--;     
      this.table1.ResumeLayout(false);    
    }
    #endregion

    #region CellButtonClicked
    private void FilesTable_CellButtonClicked(object sender, XPTable.Events.CellButtonEventArgs e)
    {                        
      if(e.Cell.Text == "Becsekkols")
      {
        ThreadPool.QueueUserWorkItem(new WaitCallback(ServerCommandExecuter),
                                     new object[2]{"Check In",e.Cell});           
      }
      else
      {
        ThreadPool.QueueUserWorkItem(new WaitCallback(ServerCommandExecuter),
                                     new object[2]{"Check Out",e.Cell});      
      }      
    }
    #endregion
    
    #region ServerCommandExecuter
    public void ServerCommandExecuter(object state)
    {
      try
      { 
        ActiveThreads++;
        log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Thread started...");
     
        //
        //Get data
        //
        object[] ObjArr = (object[])state;
        string Command = ObjArr[0].ToString();
        Cell cell = (Cell)ObjArr[1];
        
        log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Command:" + Command);        
        log.WriteInfo(Thread.CurrentThread.GetHashCode(),"(Server)FileName:" + cell.Row.Cells[1].Text);
        
        ThreadRows.Add(Thread.CurrentThread.GetHashCode().ToString(),
                       cell.Row.Index.ToString());
                       
        log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Added to ThreadRows");               
        
        string FileToUpload;
        int CurProg = 0;
        long Total = 0;          
        long FileSize = 0;
          
   
        //
        //Web Handler
        //
        WebHandler wh = new WebHandler(serverpath, 
                                       server,     
                                       user,       
                                       pass,       
                                       port);       
                
        wh.UserId  = UserId;
        wh.LogedIn = true;
             
        //
        //Check command
        //
        switch(Command)
        {
          case "Check In" :
            cell = (Cell)ObjArr[1];
            cell.Row.Cells[4].Enabled = false;
            cell.Row.Cells[3].Enabled = false; 
            cell.Row.Cells[0].Text = "Becsekkols...";
            cell.Row.Cells[0].Image = ilStates.Images[3];
            log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Check In Starting...");
          
            if(wh.CheckInNoEvent(SavePath + cell.Row.Cells[1].Text,cell.Row.Cells[1].Text))     
            {
              log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Check In (1) OK");
          
              while(wh.DoCheckIn(ref CurProg,ref Total,ref FileSize))
              {
                cell.Row.Cells[2].Data = CurProg;
              }  
              
              log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Check In (2) OK");
          
              cell.Row.Cells[3].Enabled = true;
              cell.Row.Cells[4].Enabled = false; 
              cell.Row.Cells[0].Text = "Becsekkolt";
              cell.Row.Cells[0].Image = ilStates.Images[0]; 
              log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Check In finished.");
            }
            else
            {
              cell.Row.Cells[0].Text = "Becsekkolsi hiba";
              cell.Row.BackColor = Color.Red;
              cell.Row.Cells[0].Image = ilStates.Images[4];
              MessageBox.Show(wh.LastError ,"Hiba - " + Thread.CurrentThread.GetHashCode());  
              log.WriteError("Error in (1):" + wh.LastError);             
            }   
            break;
          case "Check Out" :
            cell = (Cell)ObjArr[1];
            cell.Row.Cells[4].Enabled = false;
            cell.Row.Cells[3].Enabled = false; 
            cell.Row.Cells[0].Text = "Kicsekkols...";
            cell.Row.Cells[0].Image = ilStates.Images[3];
            log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Check Out Starting...");
          
            if(wh.CheckOutNoEvent(cell.Row.Cells[1].Text,SavePath + cell.Row.Cells[1].Text))
            { 
            
              log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Check Out (1) OK");       
          
              while(wh.DoCheckOut(ref CurProg,ref Total,ref FileSize))
              {
                cell.Row.Cells[2].Data = CurProg;
              }
              
              log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Check Out (2) OK");
          
              cell.Row.Cells[4].Enabled = true;
              cell.Row.Cells[3].Enabled = false;  
              cell.Row.Cells[0].Text = "Kicsekkolt";
              cell.Row.Cells[0].Image = ilStates.Images[1];   
              log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Check Out finished.");
            }
            else
            {
              cell.Row.Cells[0].Text = "Check Out error";
              cell.Row.BackColor = Color.Red;
              cell.Row.Cells[0].Image = ilStates.Images[4];   
              MessageBox.Show(wh.LastError ,"Hiba - " + Thread.CurrentThread.GetHashCode());    
              log.WriteError("Error in (1):" + wh.LastError);         
            }      
            break; 
          case "Upload" :
            cell = (Cell)ObjArr[1];
            FileToUpload = ObjArr[2].ToString();
            cell.Row.Cells[4].Enabled = false;
            cell.Row.Cells[3].Enabled = false; 
            cell.Row.Cells[0].Text = "Feltlts...";
            cell.Row.Cells[0].Image = ilStates.Images[3];
            log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Upload Starting...");
            log.WriteInfo(Thread.CurrentThread.GetHashCode(),"(Upload)FileName:" + FileToUpload);   
          
            if(wh.CheckInNoEvent(FileToUpload, cell.Row.Cells[1].Text))
            {
            
              log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Upload (1) OK");   
              while(wh.DoCheckIn(ref CurProg,ref Total,ref FileSize))
              {
                cell.Row.Cells[2].Data = CurProg;
              }

              log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Upload (2) OK");

              cell.Row.Cells[4].Enabled = false;
              cell.Row.Cells[3].Enabled = true;  
              cell.Row.Cells[0].Text = "Becsekkolt";
              cell.Row.Cells[0].Image = ilStates.Images[0];
              log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Upload finished.");    
            }
            else
            {
              cell.Row.Cells[0].Text = "Feltltsi hiba";
              cell.Row.BackColor = Color.Red;
              cell.Row.Cells[0].Image = ilStates.Images[4];
              MessageBox.Show(wh.LastError ,"Hiba - " + Thread.CurrentThread.GetHashCode());  
              log.WriteError("Error in (1):" + wh.LastError);           
            }
            break;                    
        }
        
        ThreadRows.Remove(Thread.CurrentThread.GetHashCode().ToString());
        
        log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Removeded from ThreadRows");
        log.WriteInfo(Thread.CurrentThread.GetHashCode(),"Thread Ended...");        
      }
      catch(System.Threading.ThreadAbortException AbortEx)
      {
        try
        {
          Row row =  FilesTableModel.Rows[Convert.ToInt32(ThreadRows[Thread.CurrentThread.GetHashCode().ToString()])];       
          row.Cells[0].Text = "Parancs elutastva.";
          row.Cells[1].Image = ilStates.Images[4];
          log.WriteError("Error: Thread aborted: " + AbortEx.Message); 
        }
        catch
        {}
        
        
        MessageBox.Show("Command canceled.",
                        "Fatal Error - " + Thread.CurrentThread.GetHashCode());   
        ThreadRows.Remove(Thread.CurrentThread.GetHashCode().ToString());                
      }
      catch(System.Exception e)
      {
        try
        {
          Row row =  FilesTableModel.Rows[Convert.ToInt32(ThreadRows[Thread.CurrentThread.GetHashCode().ToString()])];
          row.Cells[0].Text = "Fatal Error.";
          row.Cells[1].Image = ilStates.Images[4];
          row.BackColor = Color.Red;
          log.WriteError("Error: Fatal Error: Msg:" + e.Message        + Environment.NewLine +
                                             "Src:" + e.Source         + Environment.NewLine +
                                             "StT:" + e.Source         + Environment.NewLine +
                                             "InE:" + e.InnerException + Environment.NewLine +
                                             "TaS:" + e.TargetSite     + Environment.NewLine +
                                             "HlL:" + e.HelpLink); 
        }
        catch
        {}
        MessageBox.Show("Error Message: " + e.Message,
                        "Fatal Error - " + Thread.CurrentThread.GetHashCode()); 
        ThreadRows.Remove(Thread.CurrentThread.GetHashCode().ToString());       
      }
      ActiveThreads--; 
    }
    #endregion

    #region ProgressChanged
    private void wh_ProgressChangedEvent(int CurProgress, long FileSize, long TotalBytesLeft)
    {
      //CurCell.Data = CurProgress;
      this.statusBar1.Text = TotalBytesLeft + "\\" + FileSize;
      this.Refresh();
    }
    #endregion

    #region Refresh
    private void btnRefresh_Click(object sender, System.EventArgs e)
    {
      ThreadPool.QueueUserWorkItem(new WaitCallback(MakeRows));
    }
    #endregion

    #region Upload
    private void btnUpload_Click(object sender, System.EventArgs e)
    {
      if(openFileDialog1.ShowDialog() != DialogResult.Cancel)
      {
        string SName = openFileDialog1.FileName.Substring( openFileDialog1.FileName.LastIndexOf("\\")+1 );   
        FilesTableModel.Rows.Add(new Row(new Cell[5]{ 
                                                          new Cell("Upload starting...",ilStates.Images[3]),
                                                          new Cell(SName),
                                                          new Cell(0),
                                                          new Cell("Check Out"),
                                                          new Cell("Check In")
                                                          }));
        ThreadPool.QueueUserWorkItem(new WaitCallback(ServerCommandExecuter),
                                     new object[3]{"Upload",
                                                   FilesTableModel.Rows[FilesTableModel.Rows.Count-1].Cells[0],
                                                   openFileDialog1.FileName});                                                     
      }
    }
    #endregion

    #region Disconnect
    private void btnDisConnect_Click(object sender, System.EventArgs e)
    {
      if(wh != null)
      {    
        CommProgress cp = new CommProgress();
        cp.Show();
        cp.rtb.Text += "Kijelentkezs => Indts..." + Environment.NewLine + "> ";
        cp.rtb.Text += "Kapcsolds a szerverhez..." + Environment.NewLine + "> ";  
        cp.Refresh(); 
      
      
                                           
        cp.rtb.Text += "Kijelentkezs a Team Serverbol..." + Environment.NewLine + "> ";  
        cp.rtb.Text += "Krem vrjon!!!" + Environment.NewLine + "> ";     
        cp.Refresh();                      
        if(wh.Logout())   
        {
          cp.rtb.Text += "Kijelentkezs sikeres!!!" + Environment.NewLine + "> ";
          cp.Refresh();
          cp.Close();
        }
        else
        {
          cp.rtb.Text += "Hiba trtnt!!!" + Environment.NewLine + "> ";
          cp.rtb.Text += "zenet:" + wh.LastError + Environment.NewLine + "> ";
          cp.Refresh();     
        }
        cp.rtb.Text += "Muvelet befejezve." + Environment.NewLine + "> "; 
        cp.Refresh();
        cp.btnClose.Enabled = true;
        this.rtbInfos.Text += "Kapcsolat megszntetse..." + "\n";
        this.Refresh();
        FilesTableModel.Rows.Clear();
        this.rtbInfos.Text += "Befejezve." + "\n"; 
        this.Refresh();
        this.stbServer.Text = "Nincs kapcsolat";
        this.stbUser.Text = "Nincs felhasznl";  
        this.Text = "JAP Team Server Manager"; 
      }      
    }
    #endregion

    #region Exit
    private void btnExit_Click(object sender, System.EventArgs e)
    {
      if(wh != null)
      {
        if(wh.LogedIn)
        {
          wh.Logout();
        }
      }
      Environment.Exit(0);
    }
    #endregion
    
    #region Connect
    private void btnConnect_Click(object sender, System.EventArgs e)
    {
      try
      {
        ServerSelector ss = new ServerSelector();
        if(ss.ShowDialog() == DialogResult.OK)
        {
          if(wh != null)
          {
            wh.server = ss.server;
            wh.user   = ss.user;
            wh.pass   = ss.pass;
            wh.port   = ss.port;
            wh.ServerPath = ss.serverpath;
          }
          else
          {
            wh = new WebHandler(ss.serverpath,     
                                ss.server, 
                                ss.user,
                                ss.pass,
                                ss.port);
            wh.ProgressChangedEvent += new ProgressChanged(wh_ProgressChangedEvent);
          }
        
          server = ss.server;
          user   = ss.user;
          pass   = ss.pass;
          port   = ss.port;   
          serverpath = ss.serverpath;
          this.stbServer.Text = server;
          this.stbUser.Text = user;
          //ThreadMonitor tm = new ThreadMonitor();
          //tm.Show();
          
          CommProgress cp = new CommProgress();
          cp.Show();
          cp.rtb.Text += "Bejelentkezs => Indts..." + Environment.NewLine + "> ";
          cp.rtb.Text += "Kapcsolds a szerverhez..." + Environment.NewLine + "> ";  
          cp.Refresh();    
                                  
          wh.FilesChangedEvent += new FilesChanged(wh_FilesChangedEvent);
          wh.NewMessageEvent += new NewMessageDownloaded(wh_NewMessageEvent);
          wh.rtb = this.rtbInfos; //tm.richTextBox1;
                                     
          cp.rtb.Text += "Bejelentkezs a Team Serverbe..." + Environment.NewLine + "> ";  
          cp.rtb.Text += "Krem vrjon!!!" + Environment.NewLine + "> ";     
          cp.Refresh();
      
          LoginForm lf = new LoginForm();
          lf.ShowDialog();
                            
          if(wh.Login(lf.txtName.Text,lf.txtPass.Text))   
          {
            cp.rtb.Text += "Bejelentkezs sikeres!!!" + Environment.NewLine + "> ";
            cp.Refresh();
            UserId = wh.UserId;
            //ThreadPool.QueueUserWorkItem(new WaitCallback(MakeRows)); 
            this.Text = "JAP Team Server Manager - " + wh.LoginedUserName + "(" + wh.UserId + ")";
            cp.Close(); 
          }
          else
          {
            cp.rtb.Text += "Hiba trtnt!!!" + Environment.NewLine + "> ";
            cp.rtb.Text += "zenet:" + wh.LastError + Environment.NewLine + "> ";
            cp.Refresh();     
          }
          cp.rtb.Text += "Muvelet befejezve." + Environment.NewLine + "> "; 
          cp.Refresh();
          cp.btnClose.Enabled = true;          
        }
      }
      catch(System.Exception ex)
      {
        MessageBox.Show("Error: " + ex.Message,"Error");
        log.WriteError(ex.Message);
      }
    }
    #endregion
    
    #region Events
    private void wh_FilesChangedEvent(ArrayList Files)
    {
      try
      {
        if(ActiveThreads == 0)
        {
          this.Refresh(); 
          FileNames = Files;
          ThreadPool.QueueUserWorkItem(new WaitCallback(MakeRows));
        }
      }
      catch(System.Exception e)
      {
        MessageBox.Show("Hiba zenet: " + e.Message,"Hiba");
      }
    }

    private void wh_NewMessageEvent(string Message)
    {
      MessageBox.Show("zenet:" + Message,"wh_NewMessageEvent");
    }
    
    private void rtbInfos_TextChanged(object sender, System.EventArgs e)
    {
      rtbInfos.Focus();
      rtbInfos.Select(rtbInfos.TextLength,0);
      rtbInfos.ScrollToCaret();
    }

    private void btnSettings_Click(object sender, System.EventArgs e)
    {
      Settings s = new Settings();
      s.serverpath = serverpath;
      s.server     = server;
      s.user       = user;
      s.pass       = pass;
      s.port       = port;
      s.UserId     = UserId;
      s.ShowDialog();
    }
    #endregion

    private void TeamServManager_Closing(object sender, System.ComponentModel.CancelEventArgs e)
    {
      Environment.Exit(0);
    }
  }
}
